import java.awt.Point;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Scanner;


public class MainClass {
	private static String name = " ";
	public static Matchfield myField;
	public static Matchfield enemyField;
	static Socket so;
	static Command senderObject;
	static ObjectOutputStream os; 
	static ObjectInputStream is; 
	
	public static void main(String[] args) throws UnknownHostException, ClassNotFoundException, IOException {
		Scanner input = new Scanner(System.in);
		System.out.println("Bitte Name eingeben: ");
		name = input.nextLine();
		System.out.println("Warte bis alle Spieler verbunden sind...");
		
		GameInfo gi = setupConnection();
		
		myField = new Matchfield(gi.fieldSize);
		enemyField = new Matchfield(gi.fieldSize);

		for (int i = 0; i < gi.ships.size(); i++) {
			try {
				System.out.println("Schiff mit Lnge " + gi.ships.get(i) + " setzen: [int 1 - " + gi.fieldSize.x + "] [char a - " + (char) (gi.fieldSize.y + 96) + "] [char h/v (horizontal oder vertikal)]");
				String data[] = input.nextLine().split(" ");
				if (myField.setShip((int) data[1].toUpperCase().charAt(0) - 65, Integer.parseInt(data[0]) - 1, gi.ships.get(i), data[2].charAt(0))) {
					System.out.println("Schiff wurde gesetzt");
				} else {
					System.err.println("Schiff konnte nicht gesetzt werden! (zu nah an anderem Schiff, oder auerhalb des Spielfeldes)");
					i--;
				}
				myField.printArray();
			} catch (Exception ex) {
				System.err.println("Fehlerhafte Eingabe...");
				System.out.println(ex.toString());
				i--;
			}

		}
		sendCommand(new Command(Command.modes.info, Command.results.ready, new Point()));
		do {
			System.out.println("Warte bis alle Spieler ihre Schiffe gesetzt haben.");
		} while (readCommand().result != Command.results.gameStart);
		
		Command inCommand;

		
		
		do {
			if (!gi.beginner) { // Wird am Anfang ausgefhrt, wenn man nicht anfngt
				//Empfange attack
				System.out.println("Warte auf Attacke von Gegenspieler...");
				inCommand = readCommand();
				if (inCommand.mode != Command.modes.attack) {
					System.out.println("Ungltiges Objekt empfangen: " + inCommand.toString() + "\nBeende...");
					System.exit(0);
				}
				//Sende attack result
				System.out.println(gi.opponentName + " schiet auf " + inCommand.coordinate);
				if (myField.checkHit(inCommand.coordinate)) {
					sendCommand(new Command(Command.modes.result, Command.results.hit, inCommand.coordinate));
					myField.setHitOrWater(Matchfield.HITCHAR, inCommand.coordinate);
					System.out.println("Hit");
				} else {
					sendCommand(new Command(Command.modes.result, Command.results.water, inCommand.coordinate));
					myField.setHitOrWater(Matchfield.WATERCHAR, inCommand.coordinate);
					System.out.println("Water");
				}
				System.out.println("\nDein Feld:");
				myField.printArray();

				if (myField.checkLose()) {
					sendCommand(new Command(Command.modes.result, Command.results.gameOver, new Point()));
					break;
				}
			}
			gi.beginner = false;

			
			String temp[] = null;
			boolean correctInput = true;
			int x = 0, y = 0;
			do {
				try {
					System.out.println("Wo mchtest du hinschieen? [1 - " + gi.fieldSize.x + "] [A - " + (char) (gi.fieldSize.y + 64) + "]");
					temp = input.nextLine().split(" ");
					y = Integer.parseInt(temp[0]);
					x = (int) temp[1].toUpperCase().charAt(0) - 65;
				} catch (Exception e) {
					correctInput = false;
				}
			} while(!correctInput);
			//Sende attack
			MainClass.sendCommand(new Command(Command.modes.attack, Command.results.attack, new Point(x, y - 1)));
			System.out.println("Schuss auf " + x + ", " + (y - 1));
			
			//Empfange attack result
			inCommand = readCommand();
			if (inCommand.result == Command.results.gameOver) {
				System.out.println("Du hast gewonnen!");
				break;
			}
			if (inCommand.mode != Command.modes.result) {
				System.out.println("Ungltiges Objekt empfangen: " + inCommand.toString() + "\nBeende...");
				System.exit(0);
			}
			if (inCommand.result == Command.results.hit) {
				enemyField.setHitOrWater('H', inCommand.coordinate);
				System.out.println("Getroffen!");
			} else if (inCommand.result == Command.results.water) {
				enemyField.setHitOrWater('W', inCommand.coordinate);
				System.out.println("Nicht getroffen!");
			}
			System.out.println("\nGegnerisches Feld:");
			enemyField.printArray();
			
		} while(true); // myField.gmaeOver
		
		System.out.println("Spiel vorbei");
			
		input.close();
	}
	
	public static void sendCommand(Command c) {
		try {
			os.writeObject(c);
		} catch (SocketException e) {
			System.out.println("Die Verbindung konnte nicht gescheit aufgebaut werden.");
			System.out.println("Bitte starte das Programm erneut...");
			System.exit(0);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static Command readCommand() throws ClassNotFoundException, IOException {
		Command in = null;
		try {
			in = (Command) is.readObject();
		} catch(EOFException e) {
			System.out.println("Anderer Spieler hat die Verbindung verloren. Beende...");
			System.exit(0);
		}
		return in;
	}
	
	private static GameInfo setupConnection() throws UnknownHostException, IOException, ClassNotFoundException {
		so = new Socket("192.168.0.87", 54542);
		//so = new Socket("wasfuereinepara.de", 54542);
		os = new ObjectOutputStream(so.getOutputStream());
		os.writeObject(new String(name));
		System.out.println("Name " + name + " wurde gesendet");
		is = new ObjectInputStream(so.getInputStream());
		System.out.println("Verbindung wurde aufgebaut");
		return (GameInfo) is.readObject();

	}
	
}
